#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
using namespace std;

int main()
{
    vector<int> menge1;
    list<int> menge2;

    /* Elemente 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_back(i);
    }

    /* erste in zweite Menge kopieren
     *  - aufgrund von Back-Inserter einfuegend
     */
    copy (menge1.begin(), menge1.end(),
          back_inserter(menge2));

    /* zweite Menge ausgeben
     *  - nach cout kopieren
     */
    copy (menge2.begin(), menge2.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* erste in zweite Menge rueckwaerts kopieren
     *  - jetzt ueberschreibend
     */
    copy (menge1.rbegin(), menge1.rend(),
          menge2.begin());

    /* Menge nochmal ausgeben
     */
    copy (menge2.begin(), menge2.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
