#include <iostream>
#include <vector>
#include <algorithm>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge;

    /* Elemente 2 bis 7 und 1 bis 9 in die Menge einfuegen
     */
    for (int i=2; i<=7; i++) {
        menge.push_back(i);
    }
    for (int i=1; i<=9; i++) {
        menge.push_back(i);
    }

    PRINT ("vorher:           ", menge);

    /* Menge zum Heap machen
     */
    make_heap (menge.begin(), menge.end());

    PRINT ("nach make_heap(): ", menge);

    /* erstes Element aus Heap entfernen
     */
    pop_heap (menge.begin(), menge.end());
    menge.pop_back();

    PRINT ("nach pop_heap():  ", menge);

    /* neues Element in Heap einfuegen
     */
    menge.push_back (17);
    push_heap (menge.begin(), menge.end());

    PRINT ("nach push_heap(): ", menge);

    /* Menge sortieren
     *  - BEACHTE: kein Heap mehr !!!
     */
    sort_heap (menge.begin(), menge.end());

    PRINT ("nach sort_heap(): ", menge);
}
