#include <iostream>
#include <list>
#include <set>
#include <algorithm>
using namespace std;

class JedesZweite {
  private:
    int anzahl;
  public:
    JedesZweite () : anzahl(0) {
    }
    bool operator() (int elem) {
        anzahl++;
        if (anzahl == 2) {
            anzahl = 0;
            return true;
        }
        else {
            return false;
        }
    }
};

int main()
{
    list<int> liste;

    /* Elemente 6 bis 1 und 1 bis 6 in die Liste einfuegen
     */
    for (int i=1; i<=6; i++) {
        liste.push_front(i);    // vorne absteigend
        liste.push_back(i);     // hinten aufsteigend
    }

    /* Liste ausgeben
     */
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Liste ausgeben, wobei der Wert 3 jeweils entfernt wird
     */
    remove_copy (liste.begin(), liste.end(),
                 ostream_iterator<int>(cout," "),
                 3);
    cout << endl;

    /* Liste in Set "menge" mit umgekehrter Sortierung einfuegen,
     * wobei Werte kleiner 3 entfernt werden
     */
    set<int,greater<int> > menge;
    remove_copy_if (liste.begin(), liste.end(),
                    inserter (menge, menge.end()),
                    bind2nd(less<int>(),3));

    /* Set-Menge ausgeben
     *  - ohne 33 (was ohnehin nicht vorkommt)
     */
    remove_copy (menge.begin(), menge.end(),
                 ostream_iterator<int>(cout," "),
                 33);
    cout << endl;

    /* Set-Menge ausgeben,
     * wobei jedes zweite Element ausgelassen wird
     */
    remove_copy_if (menge.begin(), menge.end(),
                    ostream_iterator<int>(cout," "),
                    JedesZweite());
    cout << endl;
}
