#include <iostream>
#include <set>
using namespace std;

int main()
{
    // Typ der Menge
#ifdef __GNUC__
    typedef set<int,less<int> > IntSet;
#else
    typedef set<int> IntSet;
#endif

    IntSet menge;        // Set-Container fuer int

    /* Elemente 1 bis 6 durcheinander in die Menge einfuegen
     */
    menge.insert (3);
    menge.insert (1);
    menge.insert (5);
    menge.insert (4);
    menge.insert (6);
    menge.insert (2);

    /* Iterator ueber alle Elemente wandern lassen
     * und aktuelles Element jeweils ausgeben
     */
    IntSet::iterator pos;
    for (pos = menge.begin(); pos != menge.end(); ++pos) {
        cout << *pos << ' ';
    }
    cout << endl;
}
